searchNodes=[{"ref":"Mix.Tasks.Serum.html","title":"Mix.Tasks.Serum","module":"Mix.Tasks.Serum","type":"task","doc":"Prints a list of available Serum tasks. mix serum This task does not take any command line argument."},{"ref":"Mix.Tasks.Serum.Build.html","title":"Mix.Tasks.Serum.Build","module":"Mix.Tasks.Serum.Build","type":"task","doc":"Builds the Serum project at the specified directory. mix serum.build [(-o|--output) PATH] The website will be built into PATH if -o(--output) PATH option is given, otherwise /path/to/project/site directory. If the output directory exists and is not empty, all files and directories under that directory will be deleted before the build process begins. However, any files or directories which names start with a dot (.) are preserved, as they may contain important information such as version control-related data. Options -o(--output) (string): Specifies the output directory. Defaults to /path/to/project/site."},{"ref":"Mix.Tasks.Serum.Gen.Page.html","title":"Mix.Tasks.Serum.Gen.Page","module":"Mix.Tasks.Serum.Gen.Page","type":"task","doc":"Adds a new page to the current project. mix serum.gen.page (-t|--title) TITLE (-o|--output) OUTPUT [Options] Required Options -t(--title) (string): Title of the new page. -o(--output) (string): The path where the new page will be saved, relative to pages/ directory. It must end with one of .md, .html, or .html.eex. Other Options -l(--label) (string): Label of the new page. Defaults to the page title. -g(--group) (string): Name of a group the new page belongs to. -r(--order) (integer): The order of the new page in a group. Defaults to 0."},{"ref":"Mix.Tasks.Serum.Gen.Post.html","title":"Mix.Tasks.Serum.Gen.Post","module":"Mix.Tasks.Serum.Gen.Post","type":"task","doc":"Adds a new blog post to the current project. mix serum.gen.post (-t|--title) TITLE (-o|--output) OUTPUT [Options] Post date will be automatically set to the moment this task is executed. Required Options -t(--title) (string): Title of the new blog post. -o(--output) (string): Name of the generated post file. The actual path to the generated file will be in the form of posts/YYYY-MM-DD-&lt;OUTPUT&gt;.md. Other Options -g(--tag) (string): Tag(s) of the new post. You can provide this option zero or more times to give multiple tags to the post."},{"ref":"Mix.Tasks.Serum.Server.html","title":"Mix.Tasks.Serum.Server","module":"Mix.Tasks.Serum.Server","type":"task","doc":"Starts the Serum development server. mix serum.server [(-p|--port) PORT] This task builds the current Serum project at a temporary directory, and starts the development server. The server uses the port 8080 by default. Options -p(--port) (integer): Use a specific port instead of 8080. This is useful when the default port is not available for use."},{"ref":"Serum.html","title":"Serum","module":"Serum","type":"module","doc":"Defines Serum OTP application. Serum is a simple static website generator written in Elixir programming language. The goal of this project is to provide the way to create awesome static websites with little effort. This documentation is for developers and advanced users. For the getting started guide and the user manual, please visit the official Serum website."},{"ref":"Serum.html#start/2","title":"Serum.start/2","module":"Serum","type":"function","doc":"Starts the :serum application. This starts a supervisor process which manages some children maintaining states or data required for execution of Serum."},{"ref":"Serum.Build.html","title":"Serum.Build","module":"Serum.Build","type":"module","doc":"A module for managing the overall project build procedure."},{"ref":"Serum.Build.html#build/2","title":"Serum.Build.build/2","module":"Serum.Build","type":"function","doc":"Builds the given Serum project. Build Procedure Checks if a project definition file exists under src, checks if it&#39;s well-formed and valid, then loads it. Tries to load plugins listed in the project definition file. Checks if the system timezone is properly set. Timex requires the local timezone information to format the date/time string. If it&#39;s not set or invalid, Timex will fail. Checks if the current user has enough permission on the destination directory and cleans it if it already exists. Loads source files. See Serum.Build.FileLoader. Processes source files and produces intermediate data structures. See Serum.Build.FileProcessor. Generates HTML fragments from the intermediate data. See Serum.Build.FragmentGenerator. Renders full HTML pages from fragments and writes them to files. See Serum.Build.FileEmitter. Copies assets/ and media/ directories if they exist."},{"ref":"Serum.Build.FileEmitter.html","title":"Serum.Build.FileEmitter","module":"Serum.Build.FileEmitter","type":"module","doc":"A module responsible for writing each complete HTML page to a file."},{"ref":"Serum.Build.FileEmitter.html#run/1","title":"Serum.Build.FileEmitter.run/1","module":"Serum.Build.FileEmitter","type":"function","doc":"Write files described by %Serum.File{} to actual files on disk. Necessary subdirectories will be created if they don&#39;t exist."},{"ref":"Serum.Build.FileLoader.html","title":"Serum.Build.FileLoader","module":"Serum.Build.FileLoader","type":"module","doc":"A module responsible for loading project files."},{"ref":"Serum.Build.FileLoader.html#load_files/1","title":"Serum.Build.FileLoader.load_files/1","module":"Serum.Build.FileLoader","type":"function","doc":"Loads project files. Files will be read from four subdirectories: templates/: Template files (*.html.eex) includes/: Includable template files (*.html.eex) pages/: Pages (*.md, *.html, *.html.eex) posts/: Blog posts (*.md) The includes/ directory and the posts/ directory are optional. That is, this function won&#39;t fail even if they don&#39;t exist. The corresponding lists in the resulting map will be empty."},{"ref":"Serum.Build.FileLoader.html#t:result/0","title":"Serum.Build.FileLoader.result/0","module":"Serum.Build.FileLoader","type":"type","doc":""},{"ref":"Serum.Build.FileProcessor.html","title":"Serum.Build.FileProcessor","module":"Serum.Build.FileProcessor","type":"module","doc":"Processes the input files to produce the intermediate data."},{"ref":"Serum.Build.FileProcessor.html#process_files/2","title":"Serum.Build.FileProcessor.process_files/2","module":"Serum.Build.FileProcessor","type":"function","doc":"Processes the input files. Procedure Compiles includable templates. Compiles regular templates. Any call to the include/1 macro in a template will be expanded into the corresponding includable template by the Serum.Template.Compiler module. Processes page files. Processes blog post files. Generates post lists using information generated just before. A list of tags and their use counts is also created. Updates the Serum.GlobalBindings agent so that the above information is available later, when rendering pages into fragments or full HTML pages."},{"ref":"Serum.Build.FileProcessor.html#update_global_bindings/3","title":"Serum.Build.FileProcessor.update_global_bindings/3","module":"Serum.Build.FileProcessor","type":"function","doc":""},{"ref":"Serum.Build.FileProcessor.html#t:result/0","title":"Serum.Build.FileProcessor.result/0","module":"Serum.Build.FileProcessor","type":"type","doc":""},{"ref":"Serum.Build.FragmentGenerator.html","title":"Serum.Build.FragmentGenerator","module":"Serum.Build.FragmentGenerator","type":"module","doc":"Renders page/post/post list structs into a page fragment."},{"ref":"Serum.Build.FragmentGenerator.html#to_fragment/2","title":"Serum.Build.FragmentGenerator.to_fragment/2","module":"Serum.Build.FragmentGenerator","type":"function","doc":""},{"ref":"Serum.Build.PageGenerator.html","title":"Serum.Build.PageGenerator","module":"Serum.Build.PageGenerator","type":"module","doc":"A module responsible for rendering complete HTML pages."},{"ref":"Serum.Build.PageGenerator.html#run/2","title":"Serum.Build.PageGenerator.run/2","module":"Serum.Build.PageGenerator","type":"function","doc":""},{"ref":"Serum.DevServer.html","title":"Serum.DevServer","module":"Serum.DevServer","type":"module","doc":"The Serum development server."},{"ref":"Serum.DevServer.html#run/2","title":"Serum.DevServer.run/2","module":"Serum.DevServer","type":"function","doc":"Starts the Serum development server."},{"ref":"Serum.DevServer.LiveReloadHandler.html","title":"Serum.DevServer.LiveReloadHandler","module":"Serum.DevServer.LiveReloadHandler","type":"module","doc":"A Cowboy Websocket handler that sends signals to clients on file events."},{"ref":"Serum.DevServer.Looper.html","title":"Serum.DevServer.Looper","module":"Serum.DevServer.Looper","type":"module","doc":"A looper which accepts user inputs as server commands and processes them."},{"ref":"Serum.DevServer.Looper.html#looper/0","title":"Serum.DevServer.Looper.looper/0","module":"Serum.DevServer.Looper","type":"function","doc":"Starts the infinite command prompt loop."},{"ref":"Serum.DevServer.Service.html","title":"Serum.DevServer.Service","module":"Serum.DevServer.Service","type":"module","doc":"A GenServer that provides some utility functions while the Serum development server is running."},{"ref":"Serum.DevServer.Service.html#child_spec/1","title":"Serum.DevServer.Service.child_spec/1","module":"Serum.DevServer.Service","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Serum.DevServer.Service.html#dirty?/0","title":"Serum.DevServer.Service.dirty?/0","module":"Serum.DevServer.Service","type":"function","doc":"Checks if the source directory is marked as dirty."},{"ref":"Serum.DevServer.Service.html#port/0","title":"Serum.DevServer.Service.port/0","module":"Serum.DevServer.Service","type":"function","doc":"Returns the port number the server currently listening on."},{"ref":"Serum.DevServer.Service.html#rebuild/0","title":"Serum.DevServer.Service.rebuild/0","module":"Serum.DevServer.Service","type":"function","doc":"Rebuilds the current Serum project."},{"ref":"Serum.DevServer.Service.html#site_dir/0","title":"Serum.DevServer.Service.site_dir/0","module":"Serum.DevServer.Service","type":"function","doc":"Returns the output directory (under temporary directory)."},{"ref":"Serum.DevServer.Service.html#source_dir/0","title":"Serum.DevServer.Service.source_dir/0","module":"Serum.DevServer.Service","type":"function","doc":"Returns the source directory."},{"ref":"Serum.DevServer.Service.html#start_link/3","title":"Serum.DevServer.Service.start_link/3","module":"Serum.DevServer.Service","type":"function","doc":"Starts Serum.DevServer.Service GenServer."},{"ref":"Serum.DevServer.Service.html#subscribe/0","title":"Serum.DevServer.Service.subscribe/0","module":"Serum.DevServer.Service","type":"function","doc":"Subscribes to this GenServer for notifications."},{"ref":"Serum.File.html","title":"Serum.File","module":"Serum.File","type":"module","doc":"Defines a struct representing a file to be read or written. Fields src: Source path dest: Destination path in_data: Data read from a file out_data: Data to be written to a file"},{"ref":"Serum.File.html#read/1","title":"Serum.File.read/1","module":"Serum.File","type":"function","doc":"Reads data from a file described by the given Serum.File struct."},{"ref":"Serum.File.html#write/1","title":"Serum.File.write/1","module":"Serum.File","type":"function","doc":"Writes data to a file described by the given Serum.File struct."},{"ref":"Serum.File.html#t:t/0","title":"Serum.File.t/0","module":"Serum.File","type":"type","doc":""},{"ref":"Serum.Fragment.html","title":"Serum.Fragment","module":"Serum.Fragment","type":"module","doc":"Defines a struct representing a page fragment. Fields file: Source path. This can be nil if created internally. output: Destination path metadata: A map holding extra information about the fragment data: Contents of the page fragment"},{"ref":"Serum.Fragment.html#new/4","title":"Serum.Fragment.new/4","module":"Serum.Fragment","type":"function","doc":"Creates a new Fragment struct."},{"ref":"Serum.Fragment.html#t:t/0","title":"Serum.Fragment.t/0","module":"Serum.Fragment","type":"type","doc":""},{"ref":"Serum.Fragment.Source.html","title":"Serum.Fragment.Source","module":"Serum.Fragment.Source","type":"protocol","doc":""},{"ref":"Serum.Fragment.Source.html#to_fragment/3","title":"Serum.Fragment.Source.to_fragment/3","module":"Serum.Fragment.Source","type":"function","doc":""},{"ref":"Serum.Fragment.Source.html#t:t/0","title":"Serum.Fragment.Source.t/0","module":"Serum.Fragment.Source","type":"type","doc":""},{"ref":"Serum.GlobalBindings.html","title":"Serum.GlobalBindings","module":"Serum.GlobalBindings","type":"module","doc":"Provides an interface to an Agent which stores site-wide template variable bindings."},{"ref":"Serum.GlobalBindings.html#as_keyword/0","title":"Serum.GlobalBindings.as_keyword/0","module":"Serum.GlobalBindings","type":"function","doc":""},{"ref":"Serum.GlobalBindings.html#child_spec/1","title":"Serum.GlobalBindings.child_spec/1","module":"Serum.GlobalBindings","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Serum.GlobalBindings.html#get/1","title":"Serum.GlobalBindings.get/1","module":"Serum.GlobalBindings","type":"function","doc":""},{"ref":"Serum.GlobalBindings.html#load/1","title":"Serum.GlobalBindings.load/1","module":"Serum.GlobalBindings","type":"function","doc":""},{"ref":"Serum.GlobalBindings.html#put/2","title":"Serum.GlobalBindings.put/2","module":"Serum.GlobalBindings","type":"function","doc":""},{"ref":"Serum.GlobalBindings.html#start_link/1","title":"Serum.GlobalBindings.start_link/1","module":"Serum.GlobalBindings","type":"function","doc":""},{"ref":"Serum.HeaderParser.html","title":"Serum.HeaderParser","module":"Serum.HeaderParser","type":"module","doc":"This module takes care of parsing headers of page (or post) source files. Header is where all page or post metadata goes into, and has the following format: --- key: value ... --- where --- in the first and last line delimits the beginning and the end of the header area, and between these two lines are one or more key-value pair delimited by a colon, where key is the name of a metadata and value is the actual value of a metadata."},{"ref":"Serum.HeaderParser.html#parse_header/3","title":"Serum.HeaderParser.parse_header/3","module":"Serum.HeaderParser","type":"function","doc":"Reads lines from a binary data and extracts the header into a map. options is a keyword list which specifies the name and type of metadata the header parser expects. So the typical options should look like this: [key1: type1, key2: type2, ...] See &quot;Types&quot; section for avilable value types. required argument is a list of required keys (in atom). If the header parser cannot find required keys in the header area, it returns an error. Types Currently the HeaderParser supports following types: :string - A line of string. It can contain spaces. :integer - A decimal integer. :datetime - Date and time. Must be specified in the format of YYYY-MM-DD hh:mm:ss. This data will be interpreted as a local time. {:list, &lt;type&gt;} - A list of multiple values separated by commas. Every value must have the same type, either :string, :integer, or :datetime. You cannot make a list of lists."},{"ref":"Serum.HeaderParser.html#t:options/0","title":"Serum.HeaderParser.options/0","module":"Serum.HeaderParser","type":"type","doc":""},{"ref":"Serum.HeaderParser.html#t:parse_result/0","title":"Serum.HeaderParser.parse_result/0","module":"Serum.HeaderParser","type":"type","doc":""},{"ref":"Serum.HeaderParser.html#t:value/0","title":"Serum.HeaderParser.value/0","module":"Serum.HeaderParser","type":"type","doc":""},{"ref":"Serum.HeaderParser.html#t:value_type/0","title":"Serum.HeaderParser.value_type/0","module":"Serum.HeaderParser","type":"type","doc":""},{"ref":"Serum.Markdown.html","title":"Serum.Markdown","module":"Serum.Markdown","type":"module","doc":"This module provides functions related to dealing with markdown data."},{"ref":"Serum.Markdown.html#to_html/2","title":"Serum.Markdown.to_html/2","module":"Serum.Markdown","type":"function","doc":"Converts a markdown document into HTML."},{"ref":"Serum.Page.html","title":"Serum.Page","module":"Serum.Page","type":"module","doc":"Defines a struct describing a normal page. Fields file: Source path type: Type of source file title: Page title label: Page label group: A group the page belongs to order: Order of the page within its group url: Absolute URL of the page within the website output: Destination path data: Source data"},{"ref":"Serum.Page.html#compact/1","title":"Serum.Page.compact/1","module":"Serum.Page","type":"function","doc":""},{"ref":"Serum.Page.html#new/4","title":"Serum.Page.new/4","module":"Serum.Page","type":"function","doc":""},{"ref":"Serum.Page.html#to_fragment/3","title":"Serum.Page.to_fragment/3","module":"Serum.Page","type":"function","doc":""},{"ref":"Serum.Page.html#t:t/0","title":"Serum.Page.t/0","module":"Serum.Page","type":"type","doc":""},{"ref":"Serum.Plugin.html","title":"Serum.Plugin","module":"Serum.Plugin","type":"behaviour","doc":"A behaviour that all Serum plugin module must implement. This module allows experienced Serum users and developers to make their own Serum plugins which can extend the functionality of Serum. A Serum plugin can... Alter contents of input or output files, Execute arbitrary codes during some stages of site building, And optionally provide extra Mix tasks that extends Serum. For Plugin Developers In order for a Serum plugin to work, you must implement at least these four callbacks: name/0 version/0 elixir/0 serum/0 description/0 implements/0 Also there are a number of other callbacks you can optionally implement. Read the rest of the documentation for this module to see which callbacks you can implement and what each callback should do. For Plugin Users To enable Serum plugins, add a plugins key to your serum.exs(if it does not exist), and put names of Serum plugin modules there. %{ plugins: [ Awesome.Serum.Plugin, Great.Serum.Plugin ] } You can also restrict some plugins to run only in specific Mix environments. For example, if plugins are configured like the code below, only Awesome.Serum.Plugin plugin will be loaded when MIX_ENV is set to prod. %{ plugins: [ Awesome.Serum.Plugin, {Great.Serum.Plugin, only: :dev}, {Another.Serum.Plugin, only: [:dev, :test]} ] } The order of plugins is important, as Serum will call plugins one by one, from the first item to the last one. Therefore these two configurations below may produce different results. Configuration 1: %{ plugins: [ Awesome.Serum.Plugin, Another.Serum.Plugin ] } Configuration 2: %{ plugins: [ Another.Serum.Plugin, Awesome.Serum.Plugin ] }"},{"ref":"Serum.Plugin.html#c:build_failed/3","title":"Serum.Plugin.build_failed/3","module":"Serum.Plugin","type":"callback","doc":"Called if the build process has failed for some reason."},{"ref":"Serum.Plugin.html#c:build_started/2","title":"Serum.Plugin.build_started/2","module":"Serum.Plugin","type":"callback","doc":"Called right after the build process has started. Some necessary OTP applications or processes should be started here."},{"ref":"Serum.Plugin.html#c:build_succeeded/2","title":"Serum.Plugin.build_succeeded/2","module":"Serum.Plugin","type":"callback","doc":"Called if the whole build process has finished successfully."},{"ref":"Serum.Plugin.html#child_spec/1","title":"Serum.Plugin.child_spec/1","module":"Serum.Plugin","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Serum.Plugin.html#c:description/0","title":"Serum.Plugin.description/0","module":"Serum.Plugin","type":"callback","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:elixir/0","title":"Serum.Plugin.elixir/0","module":"Serum.Plugin","type":"callback","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:finalizing/2","title":"Serum.Plugin.finalizing/2","module":"Serum.Plugin","type":"callback","doc":"Called right before Serum exits, whether the build has succeeded or not. This is the place where you should clean up any temporary resources created in build_started/2 callback."},{"ref":"Serum.Plugin.html#c:implements/0","title":"Serum.Plugin.implements/0","module":"Serum.Plugin","type":"callback","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:name/0","title":"Serum.Plugin.name/0","module":"Serum.Plugin","type":"callback","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:processed_list/1","title":"Serum.Plugin.processed_list/1","module":"Serum.Plugin","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the processed contents and metadata here."},{"ref":"Serum.Plugin.html#c:processed_page/1","title":"Serum.Plugin.processed_page/1","module":"Serum.Plugin","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the processed contents and metadata here."},{"ref":"Serum.Plugin.html#c:processed_post/1","title":"Serum.Plugin.processed_post/1","module":"Serum.Plugin","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the processed contents and metadata here."},{"ref":"Serum.Plugin.html#c:processed_template/1","title":"Serum.Plugin.processed_template/1","module":"Serum.Plugin","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the AST and its metadata here."},{"ref":"Serum.Plugin.html#c:processing_page/1","title":"Serum.Plugin.processing_page/1","module":"Serum.Plugin","type":"callback","doc":"Called before Serum processes each input file. Plugins can alter the raw contents of input files here."},{"ref":"Serum.Plugin.html#c:processing_post/1","title":"Serum.Plugin.processing_post/1","module":"Serum.Plugin","type":"callback","doc":"Called before Serum processes each input file. Plugins can alter the raw contents of input files here."},{"ref":"Serum.Plugin.html#c:processing_template/1","title":"Serum.Plugin.processing_template/1","module":"Serum.Plugin","type":"callback","doc":"Called before Serum processes each input file. Plugins can alter the raw contents of input files here."},{"ref":"Serum.Plugin.html#c:reading_pages/1","title":"Serum.Plugin.reading_pages/1","module":"Serum.Plugin","type":"callback","doc":"Called before reading input files. Plugins can manipulate the list of files to be read and pass it to the next plugin."},{"ref":"Serum.Plugin.html#c:reading_posts/1","title":"Serum.Plugin.reading_posts/1","module":"Serum.Plugin","type":"callback","doc":"Called before reading input files. Plugins can manipulate the list of files to be read and pass it to the next plugin."},{"ref":"Serum.Plugin.html#c:reading_templates/1","title":"Serum.Plugin.reading_templates/1","module":"Serum.Plugin","type":"callback","doc":"Called before reading input files. Plugins can manipulate the list of files to be read and pass it to the next plugin."},{"ref":"Serum.Plugin.html#c:rendered_fragment/1","title":"Serum.Plugin.rendered_fragment/1","module":"Serum.Plugin","type":"callback","doc":"Called after producing a HTML fragment for each page. Plugins can modify the contents and metadata of each fragment here."},{"ref":"Serum.Plugin.html#c:rendered_page/1","title":"Serum.Plugin.rendered_page/1","module":"Serum.Plugin","type":"callback","doc":"Called when Serum has rendered a full page and it&#39;s about to write to an output file. Plugins can alter the raw contents of the page to be written."},{"ref":"Serum.Plugin.html#c:serum/0","title":"Serum.Plugin.serum/0","module":"Serum.Plugin","type":"callback","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:version/0","title":"Serum.Plugin.version/0","module":"Serum.Plugin","type":"callback","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:wrote_file/1","title":"Serum.Plugin.wrote_file/1","module":"Serum.Plugin","type":"callback","doc":"Called after writing each output to a file."},{"ref":"Serum.Plugin.html#t:plugin_spec/0","title":"Serum.Plugin.plugin_spec/0","module":"Serum.Plugin","type":"type","doc":""},{"ref":"Serum.Plugin.html#t:t/0","title":"Serum.Plugin.t/0","module":"Serum.Plugin","type":"type","doc":""},{"ref":"Serum.Plugins.LiveReloader.html","title":"Serum.Plugins.LiveReloader","module":"Serum.Plugins.LiveReloader","type":"module","doc":"A Serum plugin that injects the live reloader script at the end of HTML files. Once the page is loaded inside your web browser, the injected script tries to connect to the Serum development server via WebSocket. When the page receives &quot;reload&quot; message from the server, it refreshes the current page. If you disable this plugin, you need to manually refresh the page after you made some changes to your source files. Using the Plugin You usually don&#39;t want the script injected into pages when the Serum development server is not running. Let the plugin run only when Mix.env() is dev, and run MIX_ENV=prod mix serum.build when you are about to publish your website. # serum.exs: %{ plugins: [ {Serum.Plugins.LiveReloader, only: :dev} ] }"},{"ref":"Serum.Plugins.LiveReloader.html#description/0","title":"Serum.Plugins.LiveReloader.description/0","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.description/0."},{"ref":"Serum.Plugins.LiveReloader.html#elixir/0","title":"Serum.Plugins.LiveReloader.elixir/0","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.elixir/0."},{"ref":"Serum.Plugins.LiveReloader.html#implements/0","title":"Serum.Plugins.LiveReloader.implements/0","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.implements/0."},{"ref":"Serum.Plugins.LiveReloader.html#name/0","title":"Serum.Plugins.LiveReloader.name/0","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.name/0."},{"ref":"Serum.Plugins.LiveReloader.html#rendered_page/1","title":"Serum.Plugins.LiveReloader.rendered_page/1","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Called when Serum has rendered a full page and it&#39;s about to write to an output file. Plugins can alter the raw contents of the page to be written. Callback implementation for Serum.Plugin.rendered_page/1."},{"ref":"Serum.Plugins.LiveReloader.html#serum/0","title":"Serum.Plugins.LiveReloader.serum/0","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.serum/0."},{"ref":"Serum.Plugins.LiveReloader.html#version/0","title":"Serum.Plugins.LiveReloader.version/0","module":"Serum.Plugins.LiveReloader","type":"function","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.version/0."},{"ref":"Serum.Plugins.SitemapGenerator.html","title":"Serum.Plugins.SitemapGenerator","module":"Serum.Plugins.SitemapGenerator","type":"module","doc":"A Serum plugin that create a sitemap so that the search engine can index posts. Using the Plugin # serum.exs: %{ server_root: &quot;https://example.io&quot;, plugins: [ {Serum.Plugins.SitemapGenerator, only: :prod} ] }"},{"ref":"Serum.Plugins.SitemapGenerator.html#build_succeeded/2","title":"Serum.Plugins.SitemapGenerator.build_succeeded/2","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Called if the whole build process has finished successfully. Callback implementation for Serum.Plugin.build_succeeded/2."},{"ref":"Serum.Plugins.SitemapGenerator.html#description/0","title":"Serum.Plugins.SitemapGenerator.description/0","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.description/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#elixir/0","title":"Serum.Plugins.SitemapGenerator.elixir/0","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.elixir/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#implements/0","title":"Serum.Plugins.SitemapGenerator.implements/0","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.implements/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#name/0","title":"Serum.Plugins.SitemapGenerator.name/0","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.name/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#serum/0","title":"Serum.Plugins.SitemapGenerator.serum/0","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.serum/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#version/0","title":"Serum.Plugins.SitemapGenerator.version/0","module":"Serum.Plugins.SitemapGenerator","type":"function","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.version/0."},{"ref":"Serum.Plugins.TableOfContents.html","title":"Serum.Plugins.TableOfContents","module":"Serum.Plugins.TableOfContents","type":"module","doc":"A Serum plugin that inserts a table of contents. Using the Plugin First, add this plugin to your serum.exs: %{ plugins: [ Serum.Plugins.TableOfContents ] } This plugin works with both pages(.md, .html, and .html.eex) and blog posts(.md). Insert the &lt;serum-toc&gt; tag at the position you want to display a table of contents at. &lt;serum-toc start=&quot;2&quot; end=&quot;4&quot;&gt;&lt;/serum-toc&gt; The start and end attributes define a range of heading level this plugin recognizes. In the case of the above example, &lt;h1&gt;, &lt;h5&gt;, and &lt;h6&gt; tags are ignored when generating a table of contents. Notes You may use &lt;serum-toc&gt; tag more than once in a single page. However, all occurrences of this tag will be replaced with a table of contents generated using the attributes of the first one. That is, for example, all three tags in the code below expand to the same table of contents, showing a 2-level deep list. &lt;serum-toc start=&quot;2&quot; end=&quot;3&quot;&gt;&lt;/serum-toc&gt; ... &lt;serum-toc&gt;&lt;/serum-toc&gt; ... &lt;serum-toc&gt;&lt;/serum-toc&gt; It&#39;s recommended that you wrap a &lt;serum-toc&gt; tag with a &lt;div&gt; tag when using in a markdown file, to ensure a well-formed structure of HTML output. &lt;div&gt;&lt;serum-toc ...&gt;&lt;/serum-toc&gt;&lt;/div&gt; And finally, make sure you close every &lt;serum-toc&gt; tag properly with &lt;/serum-toc&gt;."},{"ref":"Serum.Plugins.TableOfContents.html#description/0","title":"Serum.Plugins.TableOfContents.description/0","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.description/0."},{"ref":"Serum.Plugins.TableOfContents.html#elixir/0","title":"Serum.Plugins.TableOfContents.elixir/0","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.elixir/0."},{"ref":"Serum.Plugins.TableOfContents.html#implements/0","title":"Serum.Plugins.TableOfContents.implements/0","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.implements/0."},{"ref":"Serum.Plugins.TableOfContents.html#name/0","title":"Serum.Plugins.TableOfContents.name/0","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.name/0."},{"ref":"Serum.Plugins.TableOfContents.html#rendered_fragment/1","title":"Serum.Plugins.TableOfContents.rendered_fragment/1","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Called after producing a HTML fragment for each page. Plugins can modify the contents and metadata of each fragment here. Callback implementation for Serum.Plugin.rendered_fragment/1."},{"ref":"Serum.Plugins.TableOfContents.html#serum/0","title":"Serum.Plugins.TableOfContents.serum/0","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.serum/0."},{"ref":"Serum.Plugins.TableOfContents.html#version/0","title":"Serum.Plugins.TableOfContents.version/0","module":"Serum.Plugins.TableOfContents","type":"function","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.version/0."},{"ref":"Serum.Post.html","title":"Serum.Post","module":"Serum.Post","type":"module","doc":"Defines a struct representing a blog post page. Fields file: Source path title: Post title date: Post date (formatted) raw_date: Post date (erlang tuple style) tags: A list of tags url: Absolute URL of the blog post in the website html: Post contents converted into HTML preview: Preview text of the post output: Destination path"},{"ref":"Serum.Post.html#compact/1","title":"Serum.Post.compact/1","module":"Serum.Post","type":"function","doc":""},{"ref":"Serum.Post.html#new/4","title":"Serum.Post.new/4","module":"Serum.Post","type":"function","doc":""},{"ref":"Serum.Post.html#to_fragment/3","title":"Serum.Post.to_fragment/3","module":"Serum.Post","type":"function","doc":""},{"ref":"Serum.Post.html#t:t/0","title":"Serum.Post.t/0","module":"Serum.Post","type":"type","doc":""},{"ref":"Serum.PostList.html","title":"Serum.PostList","module":"Serum.PostList","type":"module","doc":"Defines a struct representing a list of blog posts. Fields tag: Specifies by which tag the posts are filtered. Can be nil current_page: Number of current page max_page: Number of the last page title: Title of the list posts: A list of Post structs url: Absolute URL of this list page in the website prev_url: Absolute URL of the previous list page. Can be nil if this is the first page next_url: Absolute URL of the next list page. Can be nil if this is the last page output: Destination path"},{"ref":"Serum.PostList.html#compact/1","title":"Serum.PostList.compact/1","module":"Serum.PostList","type":"function","doc":""},{"ref":"Serum.PostList.html#generate/3","title":"Serum.PostList.generate/3","module":"Serum.PostList","type":"function","doc":""},{"ref":"Serum.PostList.html#to_fragment/3","title":"Serum.PostList.to_fragment/3","module":"Serum.PostList","type":"function","doc":""},{"ref":"Serum.PostList.html#t:maybe_tag/0","title":"Serum.PostList.maybe_tag/0","module":"Serum.PostList","type":"type","doc":""},{"ref":"Serum.PostList.html#t:t/0","title":"Serum.PostList.t/0","module":"Serum.PostList","type":"type","doc":""},{"ref":"Serum.Project.html","title":"Serum.Project","module":"Serum.Project","type":"module","doc":"This module defines a struct for storing Serum project metadata."},{"ref":"Serum.Project.html#default_date_format/0","title":"Serum.Project.default_date_format/0","module":"Serum.Project","type":"function","doc":""},{"ref":"Serum.Project.html#default_list_title_tag/0","title":"Serum.Project.default_list_title_tag/0","module":"Serum.Project","type":"function","doc":""},{"ref":"Serum.Project.html#new/1","title":"Serum.Project.new/1","module":"Serum.Project","type":"function","doc":"A helper function for creating a new Project struct."},{"ref":"Serum.Project.html#t:t/0","title":"Serum.Project.t/0","module":"Serum.Project","type":"type","doc":""},{"ref":"Serum.Project.ElixirValidator.html","title":"Serum.Project.ElixirValidator","module":"Serum.Project.ElixirValidator","type":"module","doc":"A module for validation of Serum project definition data."},{"ref":"Serum.Project.ElixirValidator.html#validate/1","title":"Serum.Project.ElixirValidator.validate/1","module":"Serum.Project.ElixirValidator","type":"function","doc":""},{"ref":"Serum.Project.ElixirValidator.html#t:result/0","title":"Serum.Project.ElixirValidator.result/0","module":"Serum.Project.ElixirValidator","type":"type","doc":""},{"ref":"Serum.Project.Loader.html","title":"Serum.Project.Loader","module":"Serum.Project.Loader","type":"module","doc":"A module for loading Serum project definition files."},{"ref":"Serum.Project.Loader.html#load/2","title":"Serum.Project.Loader.load/2","module":"Serum.Project.Loader","type":"function","doc":"Detects and loads Serum project definition file from the source directory. This function first looks for serum.exs. If it does not exist, it checks if serum.json exists. If none of them exists, an error is returned."},{"ref":"Serum.Renderer.html","title":"Serum.Renderer","module":"Serum.Renderer","type":"module","doc":"This module provides functions for rendering pages into HTML."},{"ref":"Serum.Renderer.html#render_fragment/2","title":"Serum.Renderer.render_fragment/2","module":"Serum.Renderer","type":"function","doc":"Renders contents into a (partial) HTML stub."},{"ref":"Serum.Result.html","title":"Serum.Result","module":"Serum.Result","type":"module","doc":"This module defines types for positive results or errors returned by functions in this project."},{"ref":"Serum.Result.html#aggregate/2","title":"Serum.Result.aggregate/2","module":"Serum.Result","type":"function","doc":"Takes a list of result objects (without returned values) and checks if there is no error. Returns :ok if there is no error. Returns an aggregated error object if there is one or more errors."},{"ref":"Serum.Result.html#aggregate_values/2","title":"Serum.Result.aggregate_values/2","module":"Serum.Result","type":"function","doc":"Takes a list of result objects (with returned values) and checks if there is no error. If there is no error, it returns {:ok, list} where list is a list of returned values. Returns an aggregated error object if there is one or more errors."},{"ref":"Serum.Result.html#show/2","title":"Serum.Result.show/2","module":"Serum.Result","type":"function","doc":"Prints an error object in a beautiful format."},{"ref":"Serum.Result.html#t:err_details/0","title":"Serum.Result.err_details/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:error/0","title":"Serum.Result.error/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:file/0","title":"Serum.Result.file/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:full_detail/0","title":"Serum.Result.full_detail/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:line/0","title":"Serum.Result.line/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:message/0","title":"Serum.Result.message/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:msg_detail/0","title":"Serum.Result.msg_detail/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:nest_detail/0","title":"Serum.Result.nest_detail/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:t/0","title":"Serum.Result.t/0","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Result.html#t:t/1","title":"Serum.Result.t/1","module":"Serum.Result","type":"type","doc":""},{"ref":"Serum.Tag.html","title":"Serum.Tag","module":"Serum.Tag","type":"module","doc":"This module defines Tag struct."},{"ref":"Serum.Tag.html#batch_create/2","title":"Serum.Tag.batch_create/2","module":"Serum.Tag","type":"function","doc":""},{"ref":"Serum.Tag.html#new/2","title":"Serum.Tag.new/2","module":"Serum.Tag","type":"function","doc":""},{"ref":"Serum.Tag.html#t:t/0","title":"Serum.Tag.t/0","module":"Serum.Tag","type":"type","doc":""},{"ref":"Serum.Template.html","title":"Serum.Template","module":"Serum.Template","type":"module","doc":"Defines a struct which stores a template and its information."},{"ref":"Serum.Template.html#new/3","title":"Serum.Template.new/3","module":"Serum.Template","type":"function","doc":""},{"ref":"Serum.Template.html#t:t/0","title":"Serum.Template.t/0","module":"Serum.Template","type":"type","doc":""},{"ref":"Serum.Template.html#t:template_type/0","title":"Serum.Template.template_type/0","module":"Serum.Template","type":"type","doc":""},{"ref":"Serum.Template.Compiler.html","title":"Serum.Template.Compiler","module":"Serum.Template.Compiler","type":"module","doc":"This module handles template loading and preprocessing."},{"ref":"Serum.Template.Compiler.html#compile_files/2","title":"Serum.Template.Compiler.compile_files/2","module":"Serum.Template.Compiler","type":"function","doc":"Compiles a list of template files. A code that requires and imports Serum.Template.Helpers is injected before the input data. The files parameter is a list of Serum.File structs representing loaded template files. That is, for each item of this list, the value of :in_data must not be nil. The options parameter is a keyword list of additional options controlling the behavior of this function. The available options are: type: Either :template or :include, defaults to :template. includes: A map where the key of each item is the name of the includable template, and the value associated with the key is a Serum.Template struct, which is an already compiled Serum template."},{"ref":"Serum.Template.Compiler.html#compile_string/2","title":"Serum.Template.Compiler.compile_string/2","module":"Serum.Template.Compiler","type":"function","doc":"Compiles the given EEx string."},{"ref":"Serum.Template.Compiler.html#t:options/0","title":"Serum.Template.Compiler.options/0","module":"Serum.Template.Compiler","type":"type","doc":""},{"ref":"Serum.Template.Compiler.html#t:templates/0","title":"Serum.Template.Compiler.templates/0","module":"Serum.Template.Compiler","type":"type","doc":""},{"ref":"Serum.Template.Helpers.html","title":"Serum.Template.Helpers","module":"Serum.Template.Helpers","type":"module","doc":"Provides helper macros for EEx templates. This module provides some helper macros for use in any templates in your Serum project, mainly related to accessing website resources. This module is automatically required and imported when each template is compiled, reducing some boilerplate codes required for creating a useful template. However, name conflicts can occur if you import other modules exporting functions/macros with the same names."},{"ref":"Serum.Template.Helpers.html#asset/1","title":"Serum.Template.Helpers.asset/1","module":"Serum.Template.Helpers","type":"macro","doc":"Returns the URL of the given asset. Examples # Suppose @site.base_url is &quot;/mysite/&quot;. &lt;%= asset(&quot;images/icon.png&quot;) %&gt; ==&gt; /mysite/assets/images/icon.png"},{"ref":"Serum.Template.Helpers.html#base/0","title":"Serum.Template.Helpers.base/0","module":"Serum.Template.Helpers","type":"macro","doc":"Returns the value of @site.base_url."},{"ref":"Serum.Template.Helpers.html#base/1","title":"Serum.Template.Helpers.base/1","module":"Serum.Template.Helpers","type":"macro","doc":"Returns the path relative to @site.base_url. Example # Suppose @site.base_url is &quot;/mysite/&quot;. &lt;%= base(&quot;/path/to/some_file.txt&quot;) %&gt; ==&gt; /mysite/path/to/some_file.txt"},{"ref":"Serum.Template.Helpers.html#page/1","title":"Serum.Template.Helpers.page/1","module":"Serum.Template.Helpers","type":"macro","doc":"Returns the URL of the given page. Examples # Suppose @site.base_url is &quot;/mysite/&quot;. &lt;%= page(&quot;profile/my-projects&quot;) %&gt; ==&gt; /mysite/profile/my-projects.html Do not append .html extension at the end of arg. &lt;%= page(&quot;profile/my-projects.html&quot;) %&gt; ==&gt; /mysite/profile/my-projects.html.html (bad)"},{"ref":"Serum.Template.Helpers.html#post/1","title":"Serum.Template.Helpers.post/1","module":"Serum.Template.Helpers","type":"macro","doc":"Returns the URL of the given blog post. Examples # Suppose @site.base_url is &quot;/mysite/&quot;. &lt;%= post(&quot;2019-02-14-sample-post&quot;) %&gt; ==&gt; /mysite/posts/2019-02-14-sample-post.html"},{"ref":"Serum.Util.html","title":"Serum.Util","module":"Serum.Util","type":"module","doc":"This module provides some frequently used shortcut functions. These functions are inlined by the compiler."},{"ref":"Serum.Util.html#msg_gen/1","title":"Serum.Util.msg_gen/1","module":"Serum.Util","type":"macro","doc":"Displays which file is generated."},{"ref":"Serum.Util.html#msg_gen/2","title":"Serum.Util.msg_gen/2","module":"Serum.Util","type":"macro","doc":"Displays which file is generated."},{"ref":"Serum.Util.html#msg_mkdir/1","title":"Serum.Util.msg_mkdir/1","module":"Serum.Util","type":"macro","doc":"Displays which directory is created."},{"ref":"Serum.Util.html#warn/1","title":"Serum.Util.warn/1","module":"Serum.Util","type":"macro","doc":"Prints a warning message to stderr."}]